JWT Response for OAuth Token Introspection
RFC 0000
Torsten Lodderstedt, Ed.
yes.com AG
torsten@lodderstedt.net
Vladimir Dzhuvinov
Connect2id Ltd.
vladimir@connect2id.com
January 2022
Security Area
Open Authentication Protocol
token introspection
JWT
oauth2
This specification proposes an additional JSON Web Token (JWT) secured response for OAuth 2.0 Token Introspection.
Introduction
OAuth 2.0 Token Introspection specifies a method for a protected resource to query an OAuth 2.0 authorization server to determine the state of an access token and obtain data associated with the access token. This enables deployments to implement opaque access tokens in an interoperable way.
The introspection response, as specified in OAuth 2.0 Token Introspection, is a plain JSON object. However, there are use cases where the resource server requires stronger assurance that the authorization server issued the token introspection response for an access token, including cases where the authorization server assumes liability for the content of the token introspection response. An example is a resource server using verified person data to create certificates, which in turn are used to create qualified electronic signatures.
In such use cases it may be useful or even required to return a signed JWT as the introspection response. This specification extends the token introspection endpoint with the capability to return responses as JWTs.
Requirements Notation and Conventions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Resource Server Management
The authorization server (AS) and the resource server (RS) maintain a strong two-way trust relationship. The resource server relies on the authorization server to obtain authorization, user and other data as input to its access control decisions and service delivery. The authorization server relies on the resource server to handle the provided data appropriately.
In the context of this specification, the token introspection endpoint is used to convey such security data and potentially also privacy sensitive data related to an access token.
In order to process the introspection requests in a secure and privacy-preserving manner, the authorization server MUST be able to identify, authenticate and authorize resource servers.
The authorization server MAY additionally encrypt the token introspection response JWTs. If encryption is used the authorization server is provisioned with encryption keys and algorithms for the RS.
The authorization server MUST be able to determine whether an RS is the audience for a particular access token and what data it is entitled to receive, otherwise the RS is not authorized to obtain data for the access token. The AS has the discretion how to fulfil this requirement. The AS could, for example, maintain a mapping between scope values and resource servers.
The requirements given above imply that the authorization server maintains credentials and other configuration data for each RS.
One way is by utilizing dynamic client registration [RFC7591] and treating every RS as an OAuth client. In this case, the authorization server is assumed to at least maintain a "client_id" and a "token_endpoint_auth_method" with complementary authentication method metadata, such as "jwks" or "client_secret". In cases where the AS needs to acquire consent to transmit data to a RS, the following client metadata fields are recommended: "client_name", "client_uri", "contacts", "tos_uri", "policy_uri".
The AS MUST restrict the use of client credentials by a RS to the calls it requires, e.g. the AS MAY restrict such a client to call the token introspection endpoint only. How the AS implements this restriction is beyond the scope of this specification.
This specification further introduces client metadata to manage the configuration options required to sign and encrypt token introspection response JWTs.
Requesting a JWT Response
A resource server requests a JWT introspection response by sending an introspection request with an Accept HTTP header field set to "application/token-introspection+jwt".
The AS MUST authenticate the caller at the token introspection endpoint. Authentication can utilize client authentication methods or a separate access token issued to the resource server and identifying it as subject.
The following is a non-normative example request, with the resource server authenticating with a private key JWT:

POST /introspect HTTP/1.1
Host: as.example.com
Accept: application/token-introspection+jwt
Content-Type: application/x-www-form-urlencoded

token=2YotnFZFEjr1zCsicMWpAA&
client_assertion_type=
 urn%3Aietf%3Aparams%3Aoauth%3Aclient-assertion-type%3Ajwt-bearer&
 client_assertion=PHNhbWxwOl[...omitted for brevity...]ZT

JWT Response
The introspection endpoint responds with a JWT, setting the Content-Type HTTP header field to "application/token-introspection+jwt" and the JWT typ ("type") header parameter to "token-introspection+jwt".
The JWT MUST include the following top-level claims:
iss
MUST be set to the issuer URL of the authorization server.
aud
MUST identify the resource server receiving the token introspection response.
iat
MUST be set to the time when the introspection response was created by the authorization server.
token_introspection
A JSON object containing the members of the token introspection response as specified in [RFC7662], Section 2.2. The separation of the introspection response members into a dedicated containing JWT claim is intended to prevent conflict and confusion with top-level JWT claims that may bear the same name.
If the access token is invalid, expired, revoked, or not intended for the calling resource server (audience), the authorization server MUST set the value of the active member in the token_introspection claim to false and MUST NOT include other members. Otherwise, the active member is set to true.
The AS SHOULD narrow down the scope value to the scopes relevant to the particular RS.
As specified in Section 2.2 of [RFC7662], implementations MAY extend the token introspection response with service-specific claims. In the context of this specification, such claims will be added as top-level members of the token_introspection claim.
Token introspection response parameter names intended to be used across domains MUST be registered in the OAuth Token Introspection Response registry defined by [RFC7662].
When the AS acts as a provider of resource owner identity claims to the RS, the AS determines based on its RS-specific policy what identity claims to return in the token introspection response. The AS MUST ensure the release of any privacy-sensitive data is legally based (see Section 9).
Further content of the introspection response is determined by the RS-specific policy at the AS.
The JWT MAY include other claims, including those from the "JSON Web Token Claims" registry established by [RFC7519]. The JWT SHOULD NOT include the sub and exp claims, as an additional prevention against misuse of the JWT as an access token (see Section 8.1).
Note: Although the JWT format is widely used as an access token format, the JWT returned in the introspection response is not an alternative representation of the introspected access token and is not intended to be used as an access token.
This specification registers the "application/token-introspection+jwt" media type, which is used as value of the typ ("type") header parameter of the JWT to indicate that the payload is a token introspection response.
The JWT is cryptographically secured as specified in [RFC7519].
Depending on the specific resource server policy the JWT is either signed, or signed and encrypted. If the JWT is signed and encrypted it MUST be a Nested JWT, as defined in JWT.
Note: An AS compliant with this specification MUST refuse to serve introspection requests that don't authenticate the caller, and return an HTTP status code 400. This is done to ensure token data is released to legitimate recipients only and prevent downgrading to [RFC7662] behavior (see Section 8.2).
The following is a non-normative example response (with line breaks for display purposes only):

HTTP/1.1 200 OK
Content-Type: application/token-introspection+jwt

eyJraWQiOiJ3RzZEIiwidHlwIjoidG9rZW4taW50cm9zcGVjdGlvbitqd3QiLCJhbGc
iOiJSUzI1NiJ9.eyJpc3MiOiJodHRwczovL2FzLmV4YW1wbGUuY29tLyIsImF1ZCI6I
mh0dHBzOi8vcnMuZXhhbXBsZS5jb20vcmVzb3VyY2UiLCJpYXQiOjE1MTQ3OTc4OTIs
InRva2VuX2ludHJvc3BlY3Rpb24iOnsiYWN0aXZlIjp0cnVlLCJpc3MiOiJodHRwczo
vL2FzLmV4YW1wbGUuY29tLyIsImF1ZCI6Imh0dHBzOi8vcnMuZXhhbXBsZS5jb20vcm
Vzb3VyY2UiLCJpYXQiOjE1MTQ3OTc4MjIsImV4cCI6MTUxNDc5Nzk0MiwiY2xpZW50X
2lkIjoicGFpQjJnb28wYSIsInNjb3BlIjoicmVhZCB3cml0ZSBkb2xwaGluIiwic3Vi
IjoiWjVPM3VwUEM4OFFyQWp4MDBkaXMiLCJiaXJ0aGRhdGUiOiIxOTgyLTAyLTAxIiw
iZ2l2ZW5fbmFtZSI6IkpvaG4iLCJmYW1pbHlfbmFtZSI6IkRvZSIsImp0aSI6InQxRm
9DQ2FaZDRYdjRPUkpVV1ZVZVRaZnNLaFczMENRQ3JXRERqd1h5NncifX0.przJMU5Gh
mNzvwtt1Sr-xa9xTkpiAg5IshbQsRiRVP_7eGR1GHYrNwQh84kxOkHCyje2g5WSRcYo
sGEVIiC-eoPJJ-qBwqwSlgx9JEeCDw2W5DjrblOI_N0Jvsq_dUeOyoWVMqlOydOBhKN
Y0smBrI4NZvEExucOm9WUJXMuJtvq1gBes-0go5j4TEv9sOP9uu81gqWTr_LOo6pgT0
tFFyZfWC4kbXPXiQ2YT6mxCiQRRNM-l9cBdF6Jx6IOrsfFhBuYdYQ_mlL19HgDDOFal
eyqmru6lKlASOsaE8dmLSeKcX91FbG79FKN8un24iwIDCbKT9xlUFl54xWVShNDFA

The example response JWT header contains the following JSON document:

{
  "typ": "token-introspection+jwt",
  "alg": "RS256",
  "kid": "wG6D"
}

The example response JWT payload contains the following JSON document:

{
  "iss":"https://as.example.com/",
  "aud":"https://rs.example.com/resource",
  "iat":1514797892,
  "token_introspection":
     {
        "active":true,
        "iss":"https://as.example.com/",
        "aud":"https://rs.example.com/resource",
        "iat":1514797822,
        "exp":1514797942,
        "client_id":"paiB2goo0a",
        "scope":"read write dolphin",
        "sub":"Z5O3upPC88QrAjx00dis",
        "birthdate":"1982-02-01",
        "given_name":"John",
        "family_name":"Doe",
        "jti":"t1FoCCaZd4Xv4ORJUWVUeTZfsKhW30CQCrWDDjwXy6w"
     }
}

Client Metadata
The authorization server determines the algorithm to secure the JWT for a particular introspection response. This decision can be based on registered metadata parameters for the resource server, supplied via dynamic client registration [RFC7591] with the resource server acting as a client, as specified below.
The parameter names follow the pattern established by OpenID Connect Dynamic Client Registration for configuring signing and encryption algorithms for JWT responses at the UserInfo endpoint.
The following client metadata parameters are introduced by this specification:
introspection_signed_response_alg
OPTIONAL. JWS algorithm (alg value) as defined in JWA for signing introspection responses. If this is specified, the response will be signed using JWS and the configured algorithm. The default, if omitted, is RS256.
introspection_encrypted_response_alg
OPTIONAL. JWE algorithm (alg value) as defined in JWA for content key encryption.
If this is specified, the response will be encrypted using JWE and the configured content encryption algorithm (introspection_encrypted_response_enc). The default, if omitted, is that no encryption is performed.
If both signing and encryption are requested, the response will be signed then encrypted, with the result being a Nested JWT, as defined in JWT.
introspection_encrypted_response_enc
OPTIONAL. JWE algorithm (enc value) as defined in JWA for content encryption of introspection responses. The default, if omitted, is A128CBC-HS256. Note: This parameter MUST NOT be specified without setting introspection_encrypted_response_alg.
Resource servers may register their public encryption keys using the jwks_uri or jwks metadata parameters.
Authorization Server Metadata
Authorization servers SHOULD publish the supported algorithms for signing and encrypting the JWT of an introspection response by utilizing OAuth 2.0 Authorization Server Metadata parameters. Resource servers use this data to parametrize their client registration requests.
The following parameters are introduced by this specification:
introspection_signing_alg_values_supported
OPTIONAL. JSON array containing a list of the JWS signing algorithms (alg values) as defined in JWA supported by the introspection endpoint to sign the response.
introspection_encryption_alg_values_supported
OPTIONAL. JSON array containing a list of the JWE encryption algorithms (alg values) as defined in JWA supported by the introspection endpoint to encrypt the content encryption key for introspection responses (content key encryption).
introspection_encryption_enc_values_supported
OPTIONAL. JSON array containing a list of the JWE encryption algorithms (enc values) as defined in JWA supported by the introspection endpoint to encrypt the response (content encryption).
Security Considerations
Cross-JWT Confusion
The iss and potentially the aud claim of a token introspection JWT can resemble those of a JWT-encoded access token. An attacker could try to exploit this and pass a JWT token introspection response as an access token to the resource server. The typ ("type") JWT header "token-introspection+jwt" and the encapsulation of the token introspection members such as sub and scope in the token_introspection claim is intended to prevent such substitution attacks. Resource servers MUST therefore check the typ JWT header value of received JWT-encoded access tokens and ensure all minimally required claims for a valid access token are present.
Resource servers MUST additionally apply the countermeasures against replay as described in [I-D.ietf-oauth-security-topics], Section 3.2.
JWT Confusion and other attacks involving JWTs are discussed in [RFC8725].
Token Data Leakage
The authorization server MUST use Transport Layer Security (TLS) 1.2 (or higher) per BCP 195 [RFC7525] in order to prevent token data leakage.
Section 2.1 of [RFC7662] permits requests to the introspection endpoint to be authorized with an access token which doesn't identify the caller. To prevent introspection of tokens by parties that are not the intended consumer the authorization server MUST require all requests to the token introspection endpoint to be authenticated.
Privacy Considerations
The token introspection response can be used to transfer personal identifiable information (PII) from the AS to the RS. The AS MUST conform to legal and jurisdictional constraints for the data transfer before any data is released to a particular RS. The details and determining of these constraints varies by jurisdiction and is outside the scope of this document.
A commonly found way to establish the legal basis for releasing PII is by explicit user consent gathered from the resource owner by the AS during the authorization flow.
It is also possible that the legal basis is established out of band, for example in an explicit contract or by the client gathering the resource owner's consent.
If the AS and the RS belong to the same legal entity (1st party scenario), there is potentially no need for an explicit user consent but the terms of service and policy of the respective service provider MUST be enforced at all times.
In any case, the AS MUST ensure that the scope of the legal basis is enforced throughout the whole process. The AS MUST retain the scope of the legal basis with the access token, e.g. in the scope value, it MUST authenticate the RS, and the AS MUST determine the data a resource server is allowed to receive based on the resource server's identity and suitable token data, e.g. the scope value.
Implementers should be aware that a token introspection request lets the AS know when the client (and potentially the user) is accessing the RS, which is also an indication of when the user is using the client. If this implication is not acceptable, implementers MUST use other means to relay access token data, for example by directly transferring the data needed by the RS within the access token.
Acknowledgements
We would like to thank Petteri Stenius, Neil Madden, Filip Skokan, Tony Nadalin, Remco Schaar, Justin Richer, Takahiko Kawasaki, Benjamin Kaduk, Robert Wilton and Roman Danyliw for their valuable feedback.
IANA Considerations
OAuth Dynamic Client Registration Metadata Registration
This specification requests registration of the following client metadata definitions in the IANA "OAuth Dynamic Client Registration Metadata" registry [IANA.OAuth.Parameters] established by [RFC7591]:
Registry Contents
Client Metadata Name:
introspection_signed_response_alg
Client Metadata Description:
String value indicating the client's desired introspection response signing algorithm.
Change Controller:
IESG
Specification Document(s):
Section 6 of [[ this specification ]]
Client Metadata Name:
introspection_encrypted_response_alg
Client Metadata Description:
String value specifying the desired introspection response content key encryption algorithm (alg value).
Change Controller:
IESG
Specification Document(s):
Section 6 of [[ this specification ]]
Client Metadata Name:
introspection_encrypted_response_enc
Client Metadata Description:
String value specifying the desired introspection response content encryption algorithm (enc value).
Change Controller:
IESG
Specification Document(s):
Section 6 of [[ this specification ]]
OAuth Authorization Server Metadata Registration
This specification requests registration of the following values in the IANA "OAuth Authorization Server Metadata" registry [IANA.OAuth.Parameters] established by [RFC8414].
Registry Contents
Metadata Name:
introspection_signing_alg_values_supported
Metadata Description:
JSON array containing a list of algorithms supported by the authorization server for introspection response signing.
Change Controller:
IESG
Specification Document(s):
Section 7 of [[ this specification ]]
Metadata Name:
introspection_encryption_alg_values_supported
Metadata Description:
JSON array containing a list of algorithms supported by the authorization server for introspection response content key encryption (alg value).
Change Controller:
IESG
Specification Document(s):
Section 7 of [[ this specification ]]
Metadata Name:
introspection_encryption_enc_values_supported
Metadata Description:
JSON array containing a list of algorithms supported by the authorization server for introspection response content encryption (enc value).
Change Controller:
IESG
Specification Document(s):
Section 7 of [[ this specification ]]
Media Type Registration
This section registers the "application/token-introspection+jwt" media type in the "Media Types" registry [IANA.MediaTypes] in the manner described in [RFC6838], which can be used to indicate that the content is a token introspection response in JWT format.
Registry Contents
Type name:
application
Subtype name:
token-introspection+jwt
Required parameters:
N/A
Optional parameters:
N/A
Encoding considerations:
binary; A token introspection response is a JWT; JWT values are encoded as a series of base64url-encoded values (with trailing '=' characters removed), some of which may be the empty string, separated by period ('.') characters.
Security considerations:
See Section 7 of this specification
Interoperability considerations:
N/A
Published specification:
Section 4 of this specification
Applications that use this media type:
Applications that produce and consume OAuth Token Introspection Responses in JWT format
Fragment identifier considerations:
N/A
Additional information:
Magic number(s):
N/A
File extension(s):
N/A
Macintosh file type code(s):
N/A
Person & email address to contact for further information:
Torsten Lodderstedt, torsten@lodderstedt.net
Intended usage:
COMMON
Restrictions on usage:
none
Author:
Torsten Lodderstedt, torsten@lodderstedt.net
Change controller:
IESG
Provisional registration?
No
JWT Claim Registration
This section registers the "token_introspection" claim in the JSON Web Token (JWT) IANA registry [IANA.JWT] in the manner described in [RFC7519].
Registry Contents
Claim name:
token_introspection
Claim description:
Token introspection response
Change Controller:
IESG
Specification Document(s):
Section 5 of [[this specification]]
References
Normative References
[OpenID.Registration]

OpenID Connect Dynamic Client Registration 1.0 incorporating errata set 1
Nat Sakimura
NRI
John Bradley
Ping Identity
Mike Jones
Microsoft
8 Nov 2014
[IANA.MediaTypes]

Media Types
IANA
IANA
[IANA.JWT]

JSON Web Token (JWT) claims registry
IANA
IANA
[IANA.OAuth.Token.Introspection]

OAuth Token Introspection Response registry
IANA
Informative References
[IANA.OAuth.Parameters]

OAuth Parameters
IANA
[RFC2119]
[RFC8174]
[RFC7591]
[RFC7662]
[RFC7519]
[I-D.ietf-oauth-security-topics]
[RFC8725]
[RFC7525]
[RFC8414]
[RFC6838]
Document History
[[ To be removed from the final specification ]]
-12
- made registration of response parameters intended for cross domain use a MUST ( in RFC 7662)
-11
- consistent normative language that the AS must authenticate all callers to the token introspection endpoint when complying with this specification
- removes text that claims from the JSON Web Token Claims registry may be included in the token_introspection claim
- updates the privacy considerations section
- fixes the example BASE64URL encoded JWT payload
-10
- added requirement to authenticate RS if privacy sensitive data is released
- reworked text on claims from different registries
- added forward reference to privacy considerations to section 5
- added text in privacy considerations regarding client/user tracking
-09
- changes the Accept and Content-Type HTTP headers from "application/json" to "application/token-introspection+jwt" so they match the registered media type
- moves the token introspection response members into a JSON object claim named "token_introspection" to provide isolation from the top-level JWT-specific claims
- "iss", "aud" and "iat" MUST be present as top-level JWT claims
- the "sub" and "exp" claims SHOULD NOT be used as top-level JWT claims as additional prevention against JWT access token substitution attacks
-08
- made difference between introspected access token and introspection response clearer
- defined semantics of JWT claims overlapping between introspected access token and introspection response as JWT
- added section about RS management
- added text about user claims including a privacy considerations section
- removed registration of OpenID Connect claims to "Token Introspection Response" registry and refer to "JWT Claims" registry instead
- added registration of "application/token-introspection+jwt" media type as type identifier of token introspection responses in JWT format
- more changed to incorporate IESG review feedback
-07
- fixed wrong description of "locale"
- added references for ISO and ITU specifications
-06
- replaced reference to RFC 7159 with reference to RFC 8259
-05
- improved wording for TLS requirement
- added RFC 2119 boilerplate
- fixed and updated some references
-04
- reworked definition of parameters in section 4
- added text on data minimization to security considerations section
- added statement regarding TLS to security considerations section
-03
- added registration for OpenID Connect Standard Claims to OAuth Token Introspection Response registry
-02
- updated references
-01
- adapted wording to preclude any accept header except "application/jwt" if encrypted responses are required
- use registered alg value RS256 for default signing algorithm
- added text on claims in the token introspection response
-00
- initial version of the WG draft
- defined default signing algorithm
- changed behavior in case resource server is set up for encryption
- Added text on token data leakage prevention to the security considerations
- moved Security Considerations section forward
WG draft
-01
- fixed typos in client meta data field names
- added OAuth Server Metadata parameters to publish algorithms supported for signing and encrypting the introspection response
- added registration of new parameters for OAuth Server Metadata and Client Registration
- added explicit request for JWT introspection response
- made iss and aud claims mandatory in introspection response
- Stylistic and clarifying edits, updates references
-00
- initial version